# python 01_supervised_plots.py data.dat

import sys
import numpy as np
import pylab as pl
import sklearn as skl

data = np.genfromtxt(sys.argv[1], delimiter=',', skip_header = 1)
classes, u, g, r, i, z = data[:, 0], data[:, 1], data[:, 2], data[:, 3], data[:, 4], data[:, 5] 
colors = u - g, g - r, r - i, i - z
names = np.array(["u - g", "g - r", "r - i", "i - z"])
cl_names = ["stars", "quasars", "white dwarfs"]

for i in range (3):
    pl.clf()
    for cl in np.arange(1, 4):
        criteria = (classes == cl)
        pl.plot (colors[i][criteria], colors[i+1][criteria], "o", markersize=2, label = cl_names[cl-1])
    #pl.plot (colors[i], colors[i+1], "o", markersize=2)
    pl.xlabel (names[i])
    pl.ylabel (names[i+1])
    pl.legend (loc = "upper left")
    pl.xlim([-1.5, 3])
    pl.ylim([-1.5, 3])
    pl.savefig ("plot_sup_" + str(i) + "_" + names[i] + "-" + names[i+1])
