# python 02_supervised_train.py data.dat
# Basic SVM using the whole training set for testing.

import sys
import numpy as np
import pylab as pl
from sklearn import svm

data = np.genfromtxt(sys.argv[1], delimiter=',', skip_header = 1)
classes, u, g, r, i, z = data[:, 0], data[:, 1], data[:, 2], data[:, 3], data[:, 4], data[:, 5] 
colors = u - g, g - r, r - i, i - z
names = np.array(["u - g", "g - r", "r - i", "i - z"])
cl_names = ["stars", "quasars", "white dwarfs"]

data_svm = np.array(colors).transpose()
clf = svm.SVC(kernel = "linear")
print len(classes)
clf.fit(data_svm, classes)
print clf

pred_class = clf.predict(data_svm)
N_match = (pred_class == classes).sum()
print "N_match = ", N_match
acc = 1. * N_match / len(classes)
print "Accuracy = ", acc

