# python 03_supervised_test.py data.dat
# Basic SVM using the holdout method

import sys
import numpy as np
import pylab as pl
from sklearn import svm, cross_validation

data = np.genfromtxt(sys.argv[1], delimiter=',', skip_header = 1)
classes, u, g, r, i, z = data[:, 0], data[:, 1], data[:, 2], data[:, 3], data[:, 4], data[:, 5] 
colors = u - g, g - r, r - i, i - z
names = np.array(["u - g", "g - r", "r - i", "i - z"])
cl_names = ["stars", "quasars", "white dwarfs"]
N = len(classes)
data_svm = np.array(colors).transpose()

print N
X_train, X_test, y_train, y_test = cross_validation.train_test_split (data_svm, classes, test_size=1./3., random_state=0)
print X_train.shape, y_train.shape
print X_test.shape, y_test.shape

clf = svm.SVC(kernel = "linear")
clf.fit(X_train, y_train)

pred_class = clf.predict(X_test)
N_match = (pred_class == y_test).sum()
print "N_match = ", N_match
acc = 1. * N_match / len(pred_class)
print "Accuracy = ", acc

