# python 04_supervised_randomSS.py data.dat
# Basic SVM using the random subsampling method

import sys
import numpy as np
import pylab as pl
from sklearn import svm, cross_validation

data = np.genfromtxt(sys.argv[1], delimiter=',', skip_header = 1)
classes, u, g, r, i, z = data[:, 0], data[:, 1], data[:, 2], data[:, 3], data[:, 4], data[:, 5] 
colors = u - g, g - r, r - i, i - z
names = np.array(["u - g", "g - r", "r - i", "i - z"])
cl_names = ["stars", "quasars", "white dwarfs"]
N = len(classes)
data_svm = np.array(colors).transpose()

print N

clf = svm.SVC(kernel = "linear")
scores = cross_validation.cross_val_score(clf, data_svm, classes, cv=5)

print "Accuracy = ", scores.mean(), "+-", scores.std()
