# python 07_supervised_RBF.py training_data.csv unlabeled_data.csv classes.csv
# Classify for real

import sys
import numpy as np
import pylab as pl
from sklearn import svm

# load training data
data = np.genfromtxt(sys.argv[1], delimiter=',', skip_header = 1)
classes, u, g, r, i, z = data[:, 0], data[:, 1], data[:, 2], data[:, 3], data[:, 4], data[:, 5] 
colors = u - g, g - r, r - i, i - z
names = np.array(["u - g", "g - r", "r - i", "i - z"])
cl_names = ["stars", "quasars", "white dwarfs"]

N = 1000
i_s = np.arange(len(classes))
np.random.shuffle(i_s)
i_s = i_s[:N]
data_svm = np.array(colors).transpose()[i_s]
classes = classes[i_s]

# load unlabeled data
data_ul = np.genfromtxt(sys.argv[2], delimiter=',', skip_header = 1)
u, g, r, i, z = data_ul[:, 0], data_ul[:, 1], data_ul[:, 2], data_ul[:, 3], data_ul[:, 4]
colors_ul = u - g, g - r, r - i, i - z
print sys.argv[2], u[0], g[0]
data_ul = np.array(colors_ul).transpose()

clf = svm.SVC (kernel = "rbf", C = 10., gamma = 10.)
clf.fit (data_svm, classes)
pred_class = clf.predict (data_ul)

print data_ul.shape, pred_class.shape
#out = np.concatenate((data_ul.transpose(), np.array([pred_class]).transpose()))
out = np.zeros ((len(pred_class), data_ul.shape[1] + 1))
out[:,:data_ul.shape[1]] = data_ul[:][:]
out[:, -1] = pred_class [:]
np.savetxt(sys.argv[3], out, delimiter=",")

